Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.

Bug 1355913

Summary: OVMF's serial console is purple
Product: [Fedora] Fedora Reporter: Andy Lutomirski <luto>
Component: edk2Assignee: Paolo Bonzini <pbonzini>
Status: CLOSED EOL QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: low Docs Contact:
Priority: unspecified    
Version: 24CC: crobinso, kraxel, lersek, pbonzini, pjones, virt-maint
Target Milestone: ---   
Target Release: ---   
Hardware: x86_64   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2017-08-08 15:33:23 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:

Description Andy Lutomirski 2016-07-13 00:31:35 UTC
Start gnome-terminal and do:

$ virtme-run --installed-kernel --qemu-opts -bios /usr/share/edk2/ovmf/OVMF_CODE.fd

First the screen goes blank, then the cursor turns purple, and then the guest boots in purple.  Admittedly, there are worse colors than purple :)

If I do instead:

$ virtme-run --installed-kernel --graphics --qemu-opts -bios /usr/share/edk2/ovmf/OVMF_CODE.fd

then it's not purple.

Comment 1 Laszlo Ersek 2016-07-13 13:45:15 UTC
This is most likely from the ConSplitterStdErrDriverBindingStart() function, in "MdeModulePkg/Universal/Console/ConSplitterDxe/ConSplitter.c":

  //
  // If both ConOut and StdErr incorporate the same Text Out device,
  // their MaxMode and QueryData should be the intersection of both.
  //
  Status = ConSplitterTextOutAddDevice (&mStdErr, TextOut, NULL, NULL);
  ConSplitterTextOutSetAttribute (&mStdErr.TextOut, EFI_TEXT_ATTR (EFI_MAGENTA, EFI_BLACK));
  if (EFI_ERROR (Status)) {
    return Status;
  }

This is not specific to OVMF, it is generic edk2 code. (I.e., the color purple itself.)

In your first command, you only have a serial terminal (I think), which is used for both console output and error output.

In your second command, you have both graphics display and serial. ConSplitterDxe multiplexes console input and console output (as text) from/to both, but only one of them (likely the graphics display) is used for error output, I think.

IOW, whatever device is being used as error output gets a default magenta foreground color set for it, apparently. When that device is the graphics display, it is not very noticeable, because no debug messages are printed to that directly (and UEFI apps like grub2, the UEFI shell, and the Display Browser set their colors explicitly). However, a bunch of other data might be printed to the serial console directly (guest kernel log, for example), which is then affected by the default magenta foreground.

I'm not too familiar with the console stuff in edk2, so this question should be best taken to edk2-devel. My "explanation" above may well be incorrect at least in some spots. Thanks.

Comment 2 Fedora End Of Life 2017-07-25 21:46:11 UTC
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 3 Fedora End Of Life 2017-08-08 15:33:23 UTC
Fedora 24 changed to end-of-life (EOL) status on 2017-08-08. Fedora 24 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.